/[MITgcm]/MITgcm/verification/testreport
ViewVC logotype

Diff of /MITgcm/verification/testreport

Parent Directory Parent Directory | Revision Log Revision Log | View Revision Graph Revision Graph | View Patch Patch

revision 1.52 by edhill, Wed Dec 1 16:59:42 2004 UTC revision 1.99 by jmc, Sat Sep 15 20:30:05 2007 UTC
# Line 11  usage() Line 11  usage()
11      echo      echo
12      echo "where possible OPTIONS are:"      echo "where possible OPTIONS are:"
13      echo "  (-help|-h)               print usage"      echo "  (-help|-h)               print usage"
14      echo "  (-mpi)                   use MPI input files"      echo "  (-mth)                   run multi threaded (using eedata.mth)"
15        echo "  (-mpi)                   compile and run using MPI"
16      echo "  (-ieee|-noieee)          if possible, use IEEE compiler flags"      echo "  (-ieee|-noieee)          if possible, use IEEE compiler flags"
17      echo "                             (DEF=\"-ieee\")"      echo "                             (DEF=\"-ieee\")"
18      echo "  (-optfile=|-of=)STRING   list of optfiles to use"      echo "  (-of=|-optfile=)STRING   list of optfiles to use"
19      echo "  (-a|-addr) STRING        list of email recipients"      echo "  (-a|-addr) STRING        list of email recipients"
20      echo "                             (DEF=\"edhill@mitgcm.org\")"      echo "                             (DEF=\"edhill@mitgcm.org\")"
21      echo "  (-t|-tdir) STRING        list of test dirs to use"      echo "  (-t|-tdir) STRING        list of group and/or exp. dirs to test"
22      echo "                             (DEF=\"\" which builds all)"      echo "                             (recognized groups: basic, tutorials)"
23        echo "                             (DEF=\"\" which test all)"
24        echo "  (-skd|-skipdir) STRING   list of exp. dirs to skip"
25        echo "                             (DEF=\"\" which test all)"
26      echo "  (-b|-bash) STRING        preferred location of a \"bash\" or"      echo "  (-b|-bash) STRING        preferred location of a \"bash\" or"
27      echo "                             Bourne-compatible \"sh\" shell"      echo "                             Bourne-compatible \"sh\" shell"
28      echo "                             (DEF=\"\" for \"bash\")"      echo "                             (DEF=\"\" for \"bash\")"
# Line 27  usage() Line 31  usage()
31      echo "                             (DEF=\"make output.txt\")"      echo "                             (DEF=\"make output.txt\")"
32      echo "  (-m|-make) STRING        command to use for \"make\""      echo "  (-m|-make) STRING        command to use for \"make\""
33      echo "                             (DEF=\"make\")"      echo "                             (DEF=\"make\")"
34      echo "  (-ptracers|-ptr) STRING  specify which ptracers to test"      echo "  (-odir) STRING           used to build output directory name"
35        echo "                             (DEF=\"hostname\")"
36        echo "  (-ptr|-ptracers) STRING  specify which ptracers to test"
37      echo "                             (DEF=\"1 2 3 4 5\")"      echo "                             (DEF=\"1 2 3 4 5\")"
38        echo "  (-match) NUMBER          Matching Criteria (number of digits)"
39        echo "                             (DEF=\"12\")"
40      echo "  (-j) JOBS                use \"make -j JOBS\" for parallel builds"      echo "  (-j) JOBS                use \"make -j JOBS\" for parallel builds"
41      echo "  (-clean)                 *ONLY* run \"make CLEAN\""      echo "  (-clean)                 *ONLY* run \"make CLEAN\""
42      echo "  (-quick|-q)              same as \"-nogenmake -noclean -nodepend\""      echo "  (-quick|-q)              same as \"-nogenmake -noclean -nodepend\""
# Line 36  usage() Line 44  usage()
44      echo "  (-noclean|-nc)           skip the \"make clean\" stage"      echo "  (-noclean|-nc)           skip the \"make clean\" stage"
45      echo "  (-nodepend|-nd)          skip the \"make depend\" stage"      echo "  (-nodepend|-nd)          skip the \"make depend\" stage"
46      echo "  (-deldir|-dd)            on success, delete the output directory"      echo "  (-deldir|-dd)            on success, delete the output directory"
47        echo "  (-ts)                    provide timing information per timestep"
48        echo "  (-papis)                 provide MFlop/s per timestep using PAPI"
49        echo "  (-pcls)                  provide MFlop/s per timestep using PCL"
50      echo      echo
51      echo "and where STRING can be a whitespace-delimited list"      echo "and where STRING can be a whitespace-delimited list"
52      echo "such as:"      echo "such as:"
# Line 83  build_mpack() Line 94  build_mpack()
94      echo "OK"      echo "OK"
95  }  }
96    
97  testoutput_for_prop()  testoutput_var()
98  {  {
99      # testoutput_for_prop dir s1 label subdir extension      # testoutput_var dir s1 label subdir reference_output
100      #      #
101      #  compares files in $dir/$subdir/output.txt and $dir/results/output.txt      #  compares 1 variable output selected from file $dir/$subdir/$OUTPUTFILE
102      #  using search strings s1 and text label      #     with same output from reference file $dir/results/$reference_output
103        #  using search strings s1 and text label
104    
105      if [ $debug -gt 0 ]; then      if [ $debug -gt 0 ]; then
106          echo testoutput_for_prop: grep "$2" $1/$4/output.txt 1>&2          echo testoutput_var: grep "$2" $1/$4/$OUTPUTFILE 1>&2
107      fi      fi
108      if [ -r $1/$4/output.txt ]; then      if [ -r $1/$4/$OUTPUTFILE ]; then
109          grep "$2" $1/$4/output.txt | sed 's/.*=//' | cat -n > tmp1.txt          grep "$2" $1/$4/$OUTPUTFILE | sed 's/.*=//' | cat -n > tmp1.txt
110          lncnt=`wc -l tmp1.txt | awk '{print $1}' `          lncntA=`wc -l tmp1.txt | awk '{print $1}' `
111          if [ $lncnt -lt 3 ]; then          if [ $lncntA -lt 3 ]; then
112              if [ $verbose -gt 0 ]; then              if [ $verbose -gt 0 ]; then
113                  echo Not enough lines of output when searching for "$2" 1>&2                  echo Not enough lines of output when searching for "$2" 1>&2
114              fi              fi
115              return 99              return 99
116          fi          fi
117      else      else
118          echo testoutput_for_prop: output.txt from model run was not readable 1>&2          echo testoutput_var: $OUTPUTFILE from model run was not readable 1>&2
119          return 99          return 99
120      fi      fi
121      if [ $debug -gt 0 ]; then      if [ $debug -gt 0 ]; then
122          echo testoutput_for_prop: grep "$2" $1/results/output.txt$5 1>&2          echo testoutput_var: grep "$2" $1/results/$5 1>&2
123      fi      fi
124      grep "$2" $1/results/output.txt$5 | sed 's/.*=//' | cat -n > tmp2.txt      grep "$2" $1/results/$5 | sed 's/.*=//' | cat -n > tmp2.txt
125      lncnt=`wc -l tmp2.txt | awk '{print $1}' `      lncntB=`wc -l tmp2.txt | awk '{print $1}' `
126      if [ $lncnt -lt 3 ]; then      if [ $lncntB -lt 3 ]; then
127          if [ $verbose -gt 0 ]; then          if [ $verbose -gt 0 ]; then
128              echo Not enough lines of output when searching for "$2" 1>&2              echo Not enough lines of output when searching for "$2" 1>&2
129          fi          fi
130          return 99          return 99
131      fi      fi
132        if [ $lncntA -ne $lncntB ]; then
133            if [ $verbose -gt 0 ]; then
134                echo Not same Nb of lines when searching for "$2" ":" $lncntA $lncntB 1>&2
135            fi
136            return 99
137        fi
138        has_nan=`cat tmp1.txt | grep -i nan | wc -l`
139        if [ $has_nan -gt 0  ] ; then
140            echo testoutput_var: $OUTPUTFILE contains $has_nan NaN values  1>&2
141            return 99
142        fi
143        has_inf=`cat tmp1.txt | grep -i inf | wc -l`
144        if [ $has_inf -gt 0  ] ; then
145            echo testoutput_var: $OUTPUTFILE contains $has_inf Inf values  1>&2
146            return 99
147        fi
148      if [ $debug -gt 0 ]; then      if [ $debug -gt 0 ]; then
149          echo testoutput_for_prop: join tmp1.txt tmp2.txt 1>&2          echo testoutput_var: join tmp1.txt tmp2.txt 1>&2
150      fi      fi
151      join tmp1.txt tmp2.txt | awk '{print $1 " " $2 " " $3}' > tmp3.txt      join tmp1.txt tmp2.txt | awk '{print $1 " " $2 " " $3}' > tmp3.txt
152      if [ $debug -gt 0 ]; then      if [ $debug -gt 0 ]; then
153          echo testoutput_for_prop: compare_lines 1>&2          echo testoutput_var: compare_lines 1>&2
154      fi      fi
155      if [ $verbose -gt 1 ]; then      if [ $verbose -gt 1 ]; then
156          cat tmp3.txt 1>&2          cat tmp3.txt 1>&2
# Line 130  testoutput_for_prop() Line 158  testoutput_for_prop()
158      echo "-1" >> tmp3.txt      echo "-1" >> tmp3.txt
159      # On the SGI O3K (*not* the O2K), "cat -n" inserts a ":" after the line number      # On the SGI O3K (*not* the O2K), "cat -n" inserts a ":" after the line number
160      cat tmp3.txt | sed -e 's|:||g' > tmp4.txt      cat tmp3.txt | sed -e 's|:||g' > tmp4.txt
161      digits_of_similarity=`./tmp_cmpnum < tmp4.txt`      digits_of_similarity=`./tr_cmpnum < tmp4.txt`
162      if [ $digits_of_similarity -eq 99 ]; then      if [ $digits_of_similarity -eq 99 ]; then
163          if [ $verbose -gt 0 ]; then          if [ $verbose -gt 0 ]; then
164              echo testoutput_for_prop: No comparison was available for \"$2\" 1>&2              echo testoutput_var: No comparison was available for \"$3\" 1>&2
165          fi          fi
166          digits_of_similarity=99          digits_of_similarity=99
167      else      else
168          if [ $verbose -gt 0 ]; then          if [ $verbose -gt 0 ]; then
169              echo There were $digits_of_similarity decimal places of similarity for \"$2\" 1>&2              echo There were $digits_of_similarity decimal places of similarity for \"$3\" 1>&2
170          fi          fi
171      fi      fi
172      rm -f tmp1.txt tmp2.txt tmp3.txt tmp4.txt      rm -f tmp1.txt tmp2.txt tmp3.txt tmp4.txt
# Line 163  dashnum() Line 191  dashnum()
191    
192  testoutput_ad()  testoutput_ad()
193  {  {
194      grep $3 $1/results_ad/output.txt_adm | awk '{print NR " " $5}' > t05.txt      grep $3 $1/results_ad/output_adm.txt | awk '{print NR " " $5}' > t05.txt
195      grep $3 $1/$2/output.txt_adm | awk '{print NR " " $5}' > t15.txt      grep $3 $1/$2/$OUTPUTFILE | awk '{print NR " " $5}' > t15.txt
196      grep $3 $1/results_ad/output.txt_adm | awk '{print NR " " $6}' > t06.txt      grep $3 $1/results_ad/output_adm.txt | awk '{print NR " " $6}' > t06.txt
197      grep $3 $1/$2/output.txt_adm | awk '{print NR " " $6}' > t16.txt      grep $3 $1/$2/$OUTPUTFILE | awk '{print NR " " $6}' > t16.txt
198      join t05.txt t15.txt > t5.txt      join t05.txt t15.txt > t5.txt
199      join t06.txt t16.txt > t6.txt      join t06.txt t16.txt > t6.txt
200      echo "-1" >> t5.txt      echo "-1" >> t5.txt
201      echo "-1" >> t6.txt      echo "-1" >> t6.txt
202      digits_5=`./tmp_cmpnum < t5.txt`      digits_5=`./tr_cmpnum < t5.txt`
203      digits_6=`./tmp_cmpnum < t6.txt`      digits_6=`./tr_cmpnum < t6.txt`
204      dashnum $digits_5 $digits_6      dashnum $digits_5 $digits_6
205      rm -f t[01][56].txt t[56].txt      rm -f t[01][56].txt t[56].txt
206  }  }
# Line 202  check_for_add_mon_output() Line 230  check_for_add_mon_output()
230      done      done
231  }  }
232    
233  testoutput()  testoutput_run()
234  {  {
235      # testoutput directory subdir extension      # testoutput_run directory subdir reference_output
236      #      #
237      #  test output in "directory"      #  test output from 1 run in "directory"
238      if test "x$ADM" = x ; then      if test "x$ADM" = x ; then
239          if [ $debug -gt 0 ]; then          # default list of output variables to be checked:
240              echo testoutput: testoutput_for_prop $1 cg2d_init_res 1>&2          #  1rst : main variable used to decide if it pass or FAIL
241          fi          #  others : number of matching digits to be printed in summary.txt
242          testoutput_for_prop $1 "cg2d_init_res" "cg2d init. residual" $2 $3; cg2dres=$?          listChk=$DEF_CHECK_LIST
243          if [ $debug -gt 0 ]; then          #  load experiment-specific list from file "tr_checklist" (if it exist)
244              echo testoutput: cg2dres=$cg2dres 1>&2          if test -r $1/$2/tr_checklist ; then listChk=`cat $1/$2/tr_checklist` ; fi
245          fi          sVar=`echo $listChk | awk '{print $1}'`
246          testoutput_for_prop $1 "dynstat_theta_min" "theta minimum" $2 $3; tmin=$?          # remove 1rst var and expand the list: + => min max mean s.d
247          testoutput_for_prop $1 "dynstat_theta_max" "theta maximum" $2 $3; tmax=$?          listVar=`echo $listChk | sed 's/ [a-zA-Z0-9]*+/&mn &mx &av &sd/g' \
248          testoutput_for_prop $1 "dynstat_theta_mean" "theta mean" $2 $3; tmean=$?                                 | sed 's/+//g' | sed "s/^$sVar//"`
249          testoutput_for_prop $1 "dynstat_theta_sd" "theta s.d." $2 $3; tsd=$?          if [ $debug -gt 0 ]; then echo "testoutput_run: listVar(I)='$listVar'" 1>&2 ; fi
250          testoutput_for_prop $1 "dynstat_salt_min" "salt minimum" $2 $3; smin=$?          for ii in 1 2 3 4 5 6 7 8 9 ; do
251          testoutput_for_prop $1 "dynstat_salt_max" "salt maximum" $2 $3; smax=$?            tst=`eval 'echo "$HAVE_PTR0'$ii'"'`
252          testoutput_for_prop $1 "dynstat_salt_mean" "salt mean" $2 $3; smean=$?           #echo "-- ptr test=" $tst "number of var=" `echo $listVar | awk '{print NF}'` 1>&2
253          testoutput_for_prop $1 "dynstat_salt_sd" "salt s.d." $2 $3; ssd=$?            if test "x$tst" != xt ; then listVar=`echo "$listVar" | sed "s/ pt$ii..//g"` ; fi
254          testoutput_for_prop $1 "dynstat_uvel_min" "U minimum" $2 $3; umin=$?          done
255          testoutput_for_prop $1 "dynstat_uvel_max" "U maximum" $2 $3; umax=$?          tst=`echo $sVar $listVar | awk '{ for(i=2;i<=NF;i++){t+=($i==$1)}; print t }'`
256          testoutput_for_prop $1 "dynstat_uvel_mean" "U mean" $2 $3; umean=$?          if test $tst != 1 ; then
257          testoutput_for_prop $1 "dynstat_uvel_sd" "U s.d." $2 $3; usd=$?            if test $tst = 0 ; then echo "==> WARNING: selected var >$sVar< not found" 1>&2
258          testoutput_for_prop $1 "dynstat_vvel_min" "V minimum" $2 $3; vmin=$?                   else echo "==> WARNING: found selected var >$sVar< $tst times" 1>&2 ; fi
259          testoutput_for_prop $1 "dynstat_vvel_max" "V maximum" $2 $3; vmax=$?            echo "==> WARNING: in checked list:" $listVar 1>&2
260          testoutput_for_prop $1 "dynstat_vvel_mean" "V mean" $2 $3; vmean=$?          #- put it back once:
261          testoutput_for_prop $1 "dynstat_vvel_sd" "V s.d." $2 $3; vsd=$?            listVar=" $sVar "`echo "$listVar " | sed "s/ $sVar / /g"`
262            fi
263          #  This is for PTRACERS          if [ $debug -gt 0 ]; then echo "testoutput_run: listVar(M)='$listVar'" 1>&2 ; fi
264          for ii in $PTRACERS_NUM ; do          echo "listVar='$listVar'" > $CDIR"/summary.txt"
265              eval `echo "p0"$ii"_min=99"`          allargs=""
266              eval `echo "p0"$ii"_max=99"`          for xx in $listVar
267              eval `echo "p0"$ii"_mean=99"`          do
268              eval `echo "p0"$ii"_sd=99"`            case $xx in
269              tst=`eval 'echo "$HAVE_PTR0'$ii'"'`             'PS')  if [ $debug -gt 0 ]
270              #echo 'tst = '$tst                    then echo testoutput_run: testoutput_var $1 cg2d_init_res 1>&2 ; fi
271              if test "x$tst" = xt ; then                    testoutput_var $1 "cg2d_init_res" "Press. Solver (cg2d)" $2 $3; yy=$?
272                  a="trcstat_ptracer0"                    if [ $debug -gt 0 ] ; then echo testoutput_run: cg2dres=$yy 1>&2 ; fi ;;
273                  testoutput_for_prop $1 "$a"$ii"_min"  "p0"$ii"_min"  $2 $3             'Cost') testoutput_var $1 "ADM  precision_derivative_cost" "ADM Cost" $2 $3; yy=$? ;;
274                  RETVAL=$? ; eval `echo "p0"$ii"_min="$RETVAL`             'Grad') testoutput_var $1 "ADM  precision_derivative_grad" "ADM Grad" $2 $3; yy=$? ;;
275                  testoutput_for_prop $1 "$a"$ii"_max"  "p0"$ii"_max"  $2 $3             'Tmn') testoutput_var $1 "dynstat_theta_min"  "Theta minimum"  $2 $3; yy=$? ;;
276                  RETVAL=$? ; eval `echo "p0"$ii"_max="$RETVAL`             'Tmx') testoutput_var $1 "dynstat_theta_max"  "Theta maximum"  $2 $3; yy=$? ;;
277                  testoutput_for_prop $1 "$a"$ii"_mean" "p0"$ii"_mean" $2 $3             'Tav') testoutput_var $1 "dynstat_theta_mean" "Theta mean"     $2 $3; yy=$? ;;
278                  RETVAL=$? ; eval `echo "p0"$ii"_mean="$RETVAL`             'Tsd') testoutput_var $1 "dynstat_theta_sd"   "Theta Std.Dev"  $2 $3; yy=$? ;;
279                  testoutput_for_prop $1 "$a"$ii"_sd"   "p0"$ii"_sd"   $2 $3             'Smn') testoutput_var $1 "dynstat_salt_min"  "Salt minimum"    $2 $3; yy=$? ;;
280                  RETVAL=$? ; eval `echo "p0"$ii"_sd="$RETVAL`             'Smx') testoutput_var $1 "dynstat_salt_max"  "Salt maximum"    $2 $3; yy=$? ;;
281              fi             'Sav') testoutput_var $1 "dynstat_salt_mean" "Salt mean"       $2 $3; yy=$? ;;
282          done             'Ssd') testoutput_var $1 "dynstat_salt_sd"   "Salt Std.Dev"    $2 $3; yy=$? ;;
283               'Umn') testoutput_var $1 "dynstat_uvel_min"  "U minimum"       $2 $3; yy=$? ;;
284          allargs="$cg2dres $tmin $tmax $tmean $tsd $smin $smax $smean $ssd"             'Umx') testoutput_var $1 "dynstat_uvel_max"  "U maximum"       $2 $3; yy=$? ;;
285          allargs="$allargs $umin $umax $umean $usd $vmin $vmax $vmean $vsd"             'Uav') testoutput_var $1 "dynstat_uvel_mean" "U mean"          $2 $3; yy=$? ;;
286          allargs="$allargs $p01_min $p01_max $p01_mean $p01_sd"             'Usd') testoutput_var $1 "dynstat_uvel_sd"   "U Std.Dev"       $2 $3; yy=$? ;;
287          allargs="$allargs $p02_min $p02_max $p02_mean $p02_sd"             'Vmn') testoutput_var $1 "dynstat_vvel_min"  "V minimum"       $2 $3; yy=$? ;;
288          allargs="$allargs $p03_min $p03_max $p03_mean $p03_sd"             'Vmx') testoutput_var $1 "dynstat_vvel_max"  "V maximum"       $2 $3; yy=$? ;;
289          allargs="$allargs $p04_min $p04_max $p04_mean $p04_sd"             'Vav') testoutput_var $1 "dynstat_vvel_mean" "V mean"          $2 $3; yy=$? ;;
290          allargs="$allargs $p05_min $p05_max $p05_mean $p05_sd"             'Vsd') testoutput_var $1 "dynstat_vvel_sd"   "V Std.Dev"       $2 $3; yy=$? ;;
291            'pt1mn'|'pt2mn'|'pt3mn'|'pt4mn'|'pt5mn') ii=`echo $xx | sed 's/pt//' | sed 's/..$//'`
292          eval "dashnum $allargs"             testoutput_var $1 "trcstat_ptracer0"$ii"_min"  "p0"$ii"_min"   $2 $3; yy=$? ;;
293            'pt1mx'|'pt2mx'|'pt3mx'|'pt4mx'|'pt5mx') ii=`echo $xx | sed 's/pt//' | sed 's/..$//'`
294               testoutput_var $1 "trcstat_ptracer0"$ii"_max"  "p0"$ii"_max"   $2 $3; yy=$? ;;
295            'pt1av'|'pt2av'|'pt3av'|'pt4av'|'pt5av') ii=`echo $xx | sed 's/pt//' | sed 's/..$//'`
296               testoutput_var $1 "trcstat_ptracer0"$ii"_mean" "p0"$ii"_mean" $2 $3; yy=$? ;;
297            'pt1sd'|'pt2sd'|'pt3sd'|'pt4sd'|'pt5sd') ii=`echo $xx | sed 's/pt//' | sed 's/..$//'`
298               testoutput_var $1 "trcstat_ptracer0"$ii"_sd"   "p0"$ii"_StDv"  $2 $3; yy=$? ;;
299                  *) yy=99; echo "WARNING: asking for var=$xx : not recognized !" 1>&2 ;;
300              esac
301              if test $xx = $sVar
302              then allargs="$allargs > $yy <"
303              else allargs="$allargs $yy"
304              fi
305            done
306    
307            nbVar=`echo $listVar | awk '{print NF}'`
308            if [ $nbVar -lt $LEN_CHECK_LIST ] ; then
309            #-- fill line (up to standard length) with dot:
310              adNul=`expr $LEN_CHECK_LIST - $nbVar | awk '{for(i=1;i<=$1;i++){print "."}}'`
311              echo $allargs $adNul
312            else
313              echo $allargs
314            fi
315    
316      else      else
317          testoutput_ad $1 $2 "precision_grdchk_result"          testoutput_ad $1 $2 "precision_grdchk_result"
# Line 286  genmakemodel() Line 336  genmakemodel()
336                  command="$command --mods=../code"                  command="$command --mods=../code"
337              else              else
338                  command="$command --mods=../code_ad"                  command="$command --mods=../code_ad"
                 command="$command -adof=../../../tools/adjoint_options/adjoint_staf"  
339              fi              fi
340              if test "x$OPTFILE" != xNONE ; then              if test "x$OPTFILE" != xNONE ; then
341                  command="$command --optfile=$OPTFILE"                  command="$command --optfile=$OPTFILE"
# Line 294  genmakemodel() Line 343  genmakemodel()
343              if test "x$IEEE" != x ; then              if test "x$IEEE" != x ; then
344                  command="$command -ieee"                  command="$command -ieee"
345              fi              fi
346                if test "x$MPI" = xt ; then
347                    command="$command -mpi"
348                fi
349                if test "x$TS" = xt ; then
350                    command="$command -ts"
351                fi
352                if test "x$PAPIS" = xt ; then
353                    command="$command -papis"
354                else
355                if test "x$PCLS" = xt ; then
356                    command="$command -pcls"
357                fi
358                fi
359              printf 'genmake ... ' 1>&2              printf 'genmake ... ' 1>&2
360              $command > make.log 2>&1              $command > make.log 2>&1
361              RETVAL=$?              RETVAL=$?
# Line 315  makeclean() Line 377  makeclean()
377  {  {
378      # makeclean directory      # makeclean directory
379      if test "x$NOCLEAN" = xt ; then      if test "x$NOCLEAN" = xt ; then
380          echo "make CLEAN skipped!"          echo "make Clean skipped!"
381      else      else
382          (          (
383              cd $1;              cd $1;
384              if test -e output.txt ; then              #if test -e $OUTPUTFILE ; then rm -f $OUTPUTFILE ; fi
                 rm -f output.txt  
             fi  
             printf 'make CLEAN ... ' 2>&1  
385              if test -r Makefile ; then              if test -r Makefile ; then
386                  $MAKE CLEAN >> make.log 2>&1                  printf 'clean build-dir: make Clean ... ' 2>&1
387                    $MAKE Clean >> make.log 2>&1
388                  RETVAL=$?                  RETVAL=$?
389                  if test "x$RETVAL" != x0 ; then                  if test "x$RETVAL" != x0 ; then
390                      tail make.log                      tail make.log
391                      echo "makeclean: \"make CLEAN\" failed" 1>&2                      echo "makeclean: \"make Clean\" failed" 1>&2
392                      cp make.log $CDIR"/make.log"                      cp make.log $CDIR"/make.log"
393                      return 1                      return 1
394                  fi                  fi
# Line 339  makeclean() Line 399  makeclean()
399      fi      fi
400  }  }
401    
402    run_clean()
403    {
404        # run_clean directory
405        if test "x$NOCLEAN" = xt ; then
406            echo "run_clean skipped!"
407        else
408            (
409                cd $1;
410                printf 'clean run-dir ... ' 2>&1
411                # part of what is done after "make clean" when doing "make CLEAN"
412                find . -name "*.meta" -exec rm {} \;
413                find . -name "*.data" -exec rm {} \;
414                find . -name "fort.*" -exec rm {} \;
415                find . -type l -exec rm {} \;
416                rm -f $EXECUTABLE *.txt STD* *diagnostics.log datetime
417                rm -rf mnc_test_*
418                echo successful 1>&2
419                exit 0
420            )
421        fi
422    }
423    
424  makedependmodel()  makedependmodel()
425  {  {
426      # makedependmodel directory      # makedependmodel directory
# Line 441  symlink_mpifiles() Line 523  symlink_mpifiles()
523    
524  linkdata()  linkdata()
525  {  {
526      # linkdata flag      # linkdata run_dir input_dir_1 input_dir_2 ...
527      #      #
528      # symbolically link data files to run directory      # symbolically link data files to run directory
529      if test "x$1" = x1 ; then      if test -d $1 ; then
530          (          (
531              cd $2              cd $1 ; shift
532              if test "x$ADM" = x ; then              if test -r "../"$1"/eedata.mth" ; then
533                  files=`( cd ../input ; ls -1 | grep -v CVS )`              # found eedata.mth in 1rst input dir and it is readable
534                  for i in $files ; do                  if test "x$MULTI_THREAD" = "xt" ; then
535                      if test ! -d "../input/"$i ; then                  # multi-threaded test: remove symbolic link & link eedata.mth
536                          ln -sf "../input/"$i $i                      if test -h eedata ; then rm -f eedata ; fi
537                      fi                      if test ! -r eedata ; then
538                  done                          ln -sf "../"$1"/eedata.mth" eedata ;
539              else                          printf 'eedata.mth ' 1>&2
                 files=`( cd ../input ; ls -1 *.bin | grep -v CVS )`  
                 for i in $files ; do  
                     if test ! -d "../input/"$i ; then  
                         ln -sf "../input/"$i $i  
                     fi  
                 done  
                 files=`( cd ../input_ad ; ls -1 | grep -v CVS )`  
                 for i in $files ; do  
                     if test ! -d "../input_ad/"$i ; then  
                         ln -sf "../input_ad/"$i $i  
540                      fi                      fi
541                  done                  else
542                    # not multi-threaded test: remove eedata symbolic link
543                        if test -h eedata ; then rm -f eedata ; fi
544                    fi
545              fi              fi
546                for ldir in $* ; do
547                    if test -d "../"$ldir ; then
548                        printf 'ldir='${ldir} 1>&2
549                        files=`( cd "../"$ldir ; ls -1 | grep -v CVS )`
550                        for i in $files ; do
551                            if test ! -d "../"$ldir/$i ; then
552                                if test ! -r $i  ; then
553                                    printf ' '$i 1>&2
554                                    ln -sf "../"$ldir"/"$i $i
555                                fi
556                            fi
557                        done
558                        if test -x "../"$ldir"/"prepare_run ; then
559                            "../"$ldir"/"prepare_run
560                        fi
561                        printf ' ; ' 1>&2
562                    fi
563                done
564          )          )
565      fi      fi
566  }  }
# Line 480  runmodel() Line 573  runmodel()
573      #  (where "$COMMAND" is relative to "directory")      #  (where "$COMMAND" is relative to "directory")
574      (      (
575          cd $1          cd $1
576          printf 'runmodel ... ' 1>&2          printf 'runmodel in %s ...' $1 1>&2
577          # make output.txt          # make output.txt
578          echo          echo
579          rm -f run.log          if test ! -x $EXECUTABLE -a -x "../"$builddir"/"$EXECUTABLE ; then
580          # echo "COMMAND='$COMMAND'"              echo " link" $EXECUTABLE "from dir ../"$builddir > run.log_00
581          # echo "pwd='"`pwd`"'"              ln -sf "../"$builddir"/"$EXECUTABLE .
582          ( eval $COMMAND ) > run.log 2>&1          fi
583          RETVAL=$?          if test ! -x $EXECUTABLE ; then
584          if test "x$RETVAL" = x0 ; then                  rm -f run.log ; touch run.log
585                    if test -f run.log_00 ; then cat run.log_00 >> run.log ; fi
586                    echo " no executable:" $EXECUTABLE >> run.log
587                    RETVAL=8
588                    ENDVAL=-1
589            else
590                if test ! -f $OUTPUTFILE -o $OUTPUTFILE -ot $EXECUTABLE ; then
591                  # output do not exist or is older than executable:
592                    rm -f run.log ; touch run.log
593                    if test -f run.log_00 ; then cat run.log_00 >> run.log ; fi
594                    ( eval $COMMAND ) >> run.log 2>&1
595                    RETVAL=$?
596                else
597                    RETVAL=0
598                    if test -f run.log ; then
599                        if test -f run.log_00 ; then cat run.log_00 >> run.log ; fi
600                        echo "---------->> $OUTPUTFILE is up to date " >> run.log 2>&1
601                    else
602                        touch run.log
603                        if test -f run.log_00 ; then cat run.log_00 >> run.log ; fi
604                        echo "---------->> $OUTPUTFILE is up to date " >> run.log 2>&1
605                        echo " no previous run.log: assume NORMAL END" >> run.log 2>&1
606                    fi
607                fi
608                ENDVAL=`cat run.log | grep -v 'ABNORMAL END' | grep -c 'NORMAL END'`
609            fi
610            rm -f run.log_00
611            #if test "x$RETVAL" = x0 ; then
612            if [ $RETVAL -eq 0 -a $ENDVAL -gt 0 ] ; then
613              tail run.log              tail run.log
614              echo successful 1>&2              echo successful 1>&2
615              # === Reduce the size of the testing emails!              # === Reduce the size of the testing emails!
616              # if test "x$ADM" = x ; then              #cp $OUTPUTFILE $CDIR"/"$OUTPUTFILE
             #   cp output.txt $CDIR"/output.txt"  
             # else  
             #   cp output.txt_adm $CDIR"/output.txt_adm"  
             # fi  
617              if test -s STDERR.0000 ; then cp STDERR.0000 $CDIR"/STDERR.0000" ; fi              if test -s STDERR.0000 ; then cp STDERR.0000 $CDIR"/STDERR.0000" ; fi
618              return 0              return 0
619          else          else
620              tail run.log              tail run.log
621              echo failed 1>&2              echo failed '(run:' $RETVAL ' end:' $ENDVAL ')' 1>&2
622              cp run.log $CDIR"/run.log"              cp run.log $CDIR"/run.log"
623              if test -s STDERR.0000 ; then cp STDERR.0000 $CDIR"/STDERR.0000" ; fi              if test -s STDERR.0000 ; then cp STDERR.0000 $CDIR"/STDERR.0000" ; fi
624              return 1              return 1
# Line 514  createcodelet() Line 631  createcodelet()
631      # create codelet for comparing model output      # create codelet for comparing model output
632    
633      printf "creating the comparison code...  "      printf "creating the comparison code...  "
634      cat > tmp_cmpnum.c <<EOF      cat > tr_cmpnum.c <<EOF
635  #include <stdio.h>  #include <stdio.h>
636  #include <math.h>  #include <math.h>
637  int main( int argc, char** argv )  {  int main( int argc, char** argv )  {
638    int linnum,best,lncnt;    int linnum,cmplin,best,lncnt;
639    double a,b,abave,relerr;    double a,b,abave,relerr;
640    best = -16;    best = -22;
641    lncnt = 0;    lncnt = 0;
642    while( 1 & (lncnt+=1) < 999 )  {    while( 1 & ( (lncnt+=1) < 999 ) )  {
643      scanf("%d", &linnum);      scanf("%d", &linnum);
644      if (linnum == -1)  break;      if (linnum == -1)  break;
645      scanf("%lf", &a);  scanf("%lf", &b);      scanf("%lf", &a);  scanf("%lf", &b);
646      abave = 0.5*(fabs(a)+fabs(b));      abave = 0.5*(fabs(a)+fabs(b));
647      if (abave > 0.0) {      if ( abave == abave ) {
648        relerr=fabs(a-b)/abave;        if (abave > 0.0) {
649        if (relerr > 0.0) {          relerr=fabs(a-b)/abave;
650          linnum = (int)log10(relerr);          if (relerr > 0.0) { cmplin = (int)rint(log10(relerr)); }
651          best = (best > linnum) ? best : linnum;          else { cmplin = -16 ; }
652            best = (best > cmplin) ? best : cmplin; }
653          else { cmplin = -22 ; }
654       /* printf("%d ; %lf ; %lf\n",cmplin,a,b); */
655        }        }
656      }     else {
657      else {     /* printf("%lf ; %lf ; %lf\n",abave,a,b); */
658        if (best == -16 && abave != 0)  best = -22;        break; }
     }  
659    }    }
660    if (lncnt == 999) best=-29;    if (lncnt == 999) best=-29;
661      if (linnum != -1) best=-99;
662    printf("%d\n", -best);    printf("%d\n", -best);
663    return 0;    return 0;
664  }  }
665  EOF  EOF
666      cc -o tmp_cmpnum tmp_cmpnum.c -lm      $CC -o tr_cmpnum tr_cmpnum.c -lm
667    
668      if [ -x ./tmp_cmpnum ]; then      if [ -x ./tr_cmpnum ]; then
669          echo "OK"          echo "OK"
670          return 0          return 0
671      else      else
672          echo          echo
673          echo "ERROR: failed to compile comparison code"          echo "ERROR: failed to compile comparison code -- please specify"
674            echo "  a C compiler using the CC environment variable."
675          exit 1          exit 1
676      fi      fi
677  }  }
# Line 562  formatresults() Line 683  formatresults()
683      nm=$1      nm=$1
684      printf '%s %s %s %s' $2 $3 $4 $5      printf '%s %s %s %s' $2 $3 $4 $5
685      shift; shift; shift; shift; shift;      shift; shift; shift; shift; shift;
686      printf '%3s' $@      listPrt=$@
687        listRes=`echo $listPrt | sed 's/>//' | sed 's/<//'`
688        xx=`echo $listPrt | sed 's/.*>//' | sed 's/<.*//' | awk '{print $1}'`
689        printf '%3s' $listPrt
690    #   line below does not work on hp-ux_ia64 : do those substitutions later on
691    #   printf '%3s' $listPrt | sed 's/ 99/ --/g' | sed 's/  > />/' | sed 's/  < /</'
692            
693      if [ $1 = '--' ]; then      if [ $xx = '..' ]; then
694            printf ' N/O '
695        elif [ $xx = '--' ]; then
696            printf ' N/O '
697        elif [ $xx = 99 ]; then
698          printf ' N/O '          printf ' N/O '
699      else      else
700          if [ $1 -gt 12 ]; then          if [ $xx -ge $MATCH_CRIT ]; then
701              printf ' pass'              printf ' pass'
702          else          else
703              printf ' FAIL'              printf ' FAIL'
# Line 578  formatresults() Line 708  formatresults()
708            
709  }  }
710    
 show_help()  
 {  
     cat - << EOF  
 $0 [-help] [-quick] [-verbose] dir1 [dir2] [...]  
   
  -help|-h      Show this help message  
  -quiet     Reduce the amount of output  
  -verbose   Produce copious amounts of output  
  -debug     Produce even more output which will mean nothing to most  
  -force     Do "make CLEAN" before compiling. This forces a complete rebuild.  
  -clean     Do "make CLEAN" after compiling and testing.  
  -cleanup   Aggresively removes all model output, executables and object files  
             and then exits. Use with care.  
   
 Normal usage:  
  $0 *       Configure, compile, run and analyze in all experiment directories  
 EOF  
 }  
   
711  scandirs()  scandirs()
712  {  {
713      if [ $# -eq 0 ]; then      if [ $# -eq 1 ]; then
714          for arg in * ; do          for arg in * ; do
715              test -d $arg/input && echo $arg              test -f $arg/$1 && echo $arg
716          done          done
717      else      else
718          echo $*          echo $*
719      fi      fi
720  }  }
721    
# Line 630  QUICK=f Line 741  QUICK=f
741  NOGENMAKE=f  NOGENMAKE=f
742  NOCLEAN=f  NOCLEAN=f
743  NODEPEND=f  NODEPEND=f
744    POSTCLEAN=f
745    
746  BASH=  BASH=
747  OPTFILE=NONE  OPTFILE=NONE
748  ADDRESSES=  ADDRESSES=
749  TESTDIRS=  TESTDIRS=
750    SKIPDIRS=
751  MPACKDIR="../tools/mpack-1.6"  MPACKDIR="../tools/mpack-1.6"
752  HAVE_MPACK=  HAVE_MPACK=
753  MPACK="$MPACKDIR/mpack"  MPACK="$MPACKDIR/mpack"
754  COMMAND=  COMMAND=
755  MAKE=make  if test "x$MAKE" = x ; then
756        MAKE=make
757    fi
758    if test "x$CC" = x ; then
759        CC=cc
760    fi
761  JOBS=  JOBS=
762  MPI=f  MPI=f
763    MULTI_THREAD=f
764    OUTDIR=
765  DELDIR=  DELDIR=
766    
767  ADM=  ADM=
# Line 649  ADM= Line 769  ADM=
769  # Additional monitor types  # Additional monitor types
770  PTRACERS_NUM="1 2 3 4 5"  PTRACERS_NUM="1 2 3 4 5"
771    
772    MATCH_CRIT=13
773    
774  printf "parsing options...  "  printf "parsing options...  "
775    
776  ac_prev=  ac_prev=
# Line 683  for ac_option ; do Line 805  for ac_option ; do
805          -tdir=* | --tdir=*)          -tdir=* | --tdir=*)
806              TESTDIRS=$ac_optarg ;;              TESTDIRS=$ac_optarg ;;
807    
808            -skipdir | --skipdir | -skd | --skd)
809                ac_prev=SKIPDIRS ;;
810            -skipdir=* | --skipdir=*)
811                SKIPDIRS=$ac_optarg ;;
812    
813          -bash | --bash | -b | --b)          -bash | --bash | -b | --b)
814              ac_prev=BASH ;;              ac_prev=BASH ;;
815          -bash=* | --bash=*)          -bash=* | --bash=*)
# Line 698  for ac_option ; do Line 825  for ac_option ; do
825          -make=* | --make=*)          -make=* | --make=*)
826              MAKE=$ac_optarg ;;              MAKE=$ac_optarg ;;
827    
828            -odir | --odir)
829                ac_prev=OUTDIR ;;
830            -odir=* | --odir=*)
831                OUTDIR=$ac_optarg ;;
832    
833          -ptracers | --ptracers | -ptr | --ptr)          -ptracers | --ptracers | -ptr | --ptr)
834              ac_prev=PTRACERS_NUM ;;              ac_prev=PTRACERS_NUM ;;
835          -ptracers=* | --ptracers=* | -ptr=* | --ptr=*)          -ptracers=* | --ptracers=* | -ptr=* | --ptr=*)
836              PTRACERS_NUM=$ac_optarg ;;              PTRACERS_NUM=$ac_optarg ;;
837    
838            -match | --match ) ac_prev=MATCH_CRIT ;;
839            -match=* | --match=* ) MATCH_CRIT=$ac_optarg ;;
840    
841          -j) ac_prev=JOBS ;;          -j) ac_prev=JOBS ;;
842          -j=*) JOBS=$ac_optarg ;;          -j=*) JOBS=$ac_optarg ;;
843    
844          -clean | --clean)          -clean | --clean)
845              CLEANUP=t ;;              CLEANUP=t ; DELDIR=t ;;
846    
847          -quick | --quick | -q | --q)          -quick | --quick | -q | --q)
848              QUICK=t ;;              QUICK=t ;;
# Line 718  for ac_option ; do Line 853  for ac_option ; do
853          -nodepend | --nodepend | -nd | --nd)          -nodepend | --nodepend | -nd | --nd)
854              NODEPEND=t ;;              NODEPEND=t ;;
855    
856            -postclean | --postclean | -pc | --pc)
857                POSTCLEAN=t ;;
858    
859          -mpi) MPI=t ;;          -mpi) MPI=t ;;
860    
861            -mth) MULTI_THREAD=t ;;
862    
863          -adm | -ad) ADM=t ;;          -adm | -ad) ADM=t ;;
864    
865          -ieee) IEEE=true ;;          -ieee) IEEE=true ;;
# Line 731  for ac_option ; do Line 871  for ac_option ; do
871    
872          -deldir | -dd) DELDIR=t ;;          -deldir | -dd) DELDIR=t ;;
873    
874            -ts) TS=t;;
875    
876            -papis) PAPIS=t;;
877    
878            -pcls) PCL=t;;
879    
880          -*)          -*)
881              echo "Error: unrecognized option: "$ac_option              echo "Error: unrecognized option: "$ac_option
882              usage              usage
# Line 751  if test "x$QUICK" = xt ; then Line 897  if test "x$QUICK" = xt ; then
897      NODEPEND=t      NODEPEND=t
898  fi  fi
899    
900    #- setting for forward or ADM testing
901    if test "x$ADM" = xt ; then
902        code_dir=code_ad
903        input_dirs='input_ad input'
904        ref_outp="output_adm.txt"
905        EXECUTABLE="mitgcmuv_ad"
906    else
907        code_dir=code
908        input_dirs='input'
909        ref_outp="output.txt"
910        EXECUTABLE="mitgcmuv"
911    fi
912    
913  if test "x$TESTDIRS" = x ; then  if test "x$TESTDIRS" = x ; then
914      TESTDIRS=`scandirs`      if test "x$ADM" = xt ; then
915            LIST=`scandirs results_ad/$ref_outp`
916        else
917            LIST=`scandirs results/$ref_outp`
918        fi
919    else
920        #- expand group of experiments:
921        LIST=" "
922        for xx in $TESTDIRS
923        do
924          case $xx in
925            'basic') LIST=${LIST}" aim.5l_cs hs94.128x64x5 ideal_2D_oce"
926                     LIST=${LIST}" lab_sea tutorial_baroclinic_gyre"
927                     LIST=${LIST}" tutorial_global_oce_latlon tutorial_plume_on_slope"
928                    ;;
929            'tutorials')
930                     LIST=${LIST}" "`ls | grep 'tutorial_'` ;;
931            *)       LIST=${LIST}" "$xx ;;
932          esac
933        done
934  fi  fi
935    #echo 'LIST='${LIST}'<'
936    #- skip dirs, remove duplicate and non-directory:
937    TESTDIRS=" "
938    count=0
939    for xx in $LIST
940    do
941        yy=`echo $SKIPDIRS | grep -c $xx`
942        if test $yy = 0 ; then
943            if test -d $xx ; then
944                yy=`echo $TESTDIRS | grep -c $xx`
945                if test $yy = 0 ; then TESTDIRS=${TESTDIRS}" "$xx ; fi
946            else count=1 ;
947                echo ""; echo -n " -- skip \"$xx\" (not a directory !)"
948            fi
949        else
950            if test $count = 1 ; then echo -n ", \"$xx\""
951            else count=1 ; echo "" ;  echo -n " skip: \"$xx\""
952            fi
953        fi
954    done
955    if test $count = 1 ; then echo "" ; echo -n " ... " ; fi
956    #echo 'TESTDIRS='${TESTDIRS}'<'
957    
958  if test "x$OPTFILE" = xNONE -a "x$MITGCM_OF" != x ; then  if test "x$OPTFILE" = xNONE -a "x$MITGCM_OF" != x ; then
959      OPTFILE=$MITGCM_OF      OPTFILE=$MITGCM_OF
960  fi  fi
961    
962  if test "x$ADM" = xt -a "x$COMMAND" = x ; then  OUTPUTFILE=$ref_outp
     COMMAND="./mitgcmuv_ad > output.txt_adm 2>&1"  
 fi  
   
963  if test "x$COMMAND" = x ; then  if test "x$COMMAND" = x ; then
964      COMMAND="$MAKE output.txt"      COMMAND="./$EXECUTABLE > $OUTPUTFILE"
965  fi  fi
966    if test "x$MPI" = xt ; then
967        OUTPUTFILE="STDOUT.0000"
968    fi
969    
970    #echo "OK"
971    echo "OK (COMMAND= $COMMAND )"
972    
973  echo "OK"  # set the Default List of output variables to be checked:
974    #  (use default or load experiment-specific list from file "tr_checklist")
975    # content : 1rst = main variable used to decide if it pass or FAIL
976    #         others = number of matching digits to be printed in summary.txt
977    if test "x$ADM" = x ; then
978        DEF_CHECK_LIST='PS PS T+ S+ U+ V+ pt1+ pt2+ pt3+ pt4+ pt5+'
979        EMPTY_RESULTS='.. .. .. .. .. .. .. .. .. .. .. .. .. .. .. .. ..'
980        LEN_CHECK_LIST=`echo $DEF_CHECK_LIST | sed 's/ [a-zA-Z0-9]*+/&mn &mx &av &sd/g' | awk '{print NF-1}'`
981        ii=`echo $EMPTY_RESULTS | awk '{print NF}'`
982        EMPTY_RESULTS=$EMPTY_RESULTS`expr $LEN_CHECK_LIST - $ii | awk 'BEGIN{FS=":"}{for(i=1;i<=$1;i++){printf "  ."}}'`
983    else
984        DEF_CHECK_LIST='Cost Cost Grad'
985        EMPTY_RESULTS='.. ..'
986        LEN_CHECK_LIST=`echo $DEF_CHECK_LIST | sed 's/ [a-zA-Z0-9]*+/&mn &mx &av &sd/g' | awk '{print NF-1}'`
987    fi
988    
989  #  create the FORTRAN comparison code  #  create the FORTRAN comparison code
990  createcodelet  createcodelet
# Line 784  MACH=`hostname` Line 1001  MACH=`hostname`
1001  UNAMEA=`uname -a`  UNAMEA=`uname -a`
1002  DATE=`date +%Y%m%d`  DATE=`date +%Y%m%d`
1003  BASE="tr_"$MACH"_"$DATE"_"  BASE="tr_"$MACH"_"$DATE"_"
1004    if test "x$OUTDIR" != x ; then
1005        BASE="tr_"$OUTDIR"_"$DATE"_"
1006    fi
1007  DNUM=0  DNUM=0
1008  DRESULTS="$BASE$DNUM"  DRESULTS="$BASE$DNUM"
1009  while test -e $DRESULTS ; do  while test -e $DRESULTS ; do
# Line 829  fi Line 1049  fi
1049  echo  echo
1050  echo >> $SUMMARY  echo >> $SUMMARY
1051  if test "x$ADM" = x ; then  if test "x$ADM" = x ; then
1052      line_0="            ----T-----  ----S-----  ----U-----  ----V-----"      if [ $MATCH_CRIT -lt 10 ] ;
1053        then line_0="default  "$MATCH_CRIT ;
1054        else line_0="default "$MATCH_CRIT ; fi
1055           line_0="$line_0  ----T-----  ----S-----  ----U-----  ----V-----"
1056    #   line_0="            ----T-----  ----S-----  ----U-----  ----V-----"
1057      line_1="G D M    c        m  s        m  s        m  s        m  s"      line_1="G D M    c        m  s        m  s        m  s        m  s"
1058      line_2="E p a R  g  m  m  e  .  m  m  e  .  m  m  e  .  m  m  e  ."      line_2="E p a R  g  m  m  e  .  m  m  e  .  m  m  e  .  m  m  e  ."
1059      line_3="N n k u  2  i  a  a  d  i  a  a  d  i  a  a  d  i  a  a  d"      line_3="N n k u  2  i  a  a  d  i  a  a  d  i  a  a  d  i  a  a  d"
# Line 868  for dir in $TESTDIRS ; do Line 1092  for dir in $TESTDIRS ; do
1092      #  Cleanup only!      #  Cleanup only!
1093      if test "x$CLEANUP" = xt ; then      if test "x$CLEANUP" = xt ; then
1094          if test -r $dir/build/Makefile ; then          if test -r $dir/build/Makefile ; then
1095                echo '  ------  clean dir:' $dir/build
1096              ( cd $dir/build ; make CLEAN )              ( cd $dir/build ; make CLEAN )
1097          fi          fi
1098          if test -r $dir/input/Makefile ; then          if test -d $dir/run/CVS ; then
1099              ( cd $dir/input ; make CLEAN )              echo '  ------  clean dir:' $dir/run
1100                run_clean $dir/run
1101          fi          fi
1102            (
1103                cd $dir
1104                rm -rf tr_run.*
1105            )
1106          continue          continue
1107      fi      fi
1108    
# Line 880  for dir in $TESTDIRS ; do Line 1110  for dir in $TESTDIRS ; do
1110      #  results in the correct location--or skip this directory!      #  results in the correct location--or skip this directory!
1111      fout=      fout=
1112      if test "x$ADM" = x ; then      if test "x$ADM" = x ; then
1113          fout=$dir"/results/output.txt"          fout=$dir"/results/"$ref_outp
         check_for_add_mon_output  $fout  
1114      else      else
1115          fout=$dir"/results_ad/output.txt_adm"          fout=$dir"/results_ad/"$ref_outp
1116      fi      fi
1117      if test ! -r $fout ; then      if test ! -r $fout ; then
1118          echo "can't read \"$fout\" -- skipping $dir"          echo "can't read \"$fout\" -- skipping $dir"
1119          continue          continue
1120      fi      fi
1121        if test "x$ADM" = x ; then
1122            check_for_add_mon_output  $fout
1123        fi
1124    
1125      # Check for additional types of monitor output      # Check for additional types of monitor output
1126    
1127      builddir="input"      builddir="build"
1128      rundir="input"      if test ! -d $dir/$builddir ; then mkdir $dir/$builddir ; fi
1129      use_seperate_build=0      rundir="run"
1130      if test -d $dir/build -a -r $dir/build ; then      if test ! -d $dir/$rundir ; then
1131          builddir="build"          rundir=$builddir
         rundir="build"  
         use_seperate_build=1  
         linkdata $use_seperate_build $dir/$rundir  
1132      fi      fi
1133            CODE_DIR=$dir/$code_dir
1134        BUILD_DIR=$dir/$builddir
1135    
1136        if test ! -r $CODE_DIR"/SIZE.h_mpi" -a "x$MPI" = "xt" ; then
1137            echo "can't find \"$CODE_DIR/SIZE.h_mpi\" -- skipping $dir"
1138            continue
1139        fi
1140        if test ! -r $dir"/input/eedata.mth" -a "x$MULTI_THREAD" = "xt" ; then
1141            echo "can't find \"$dir/input/eedata.mth\" -- skipping $dir"
1142            continue
1143        fi
1144    
1145      #  Check whether there are "extra runs" for this testdir      #  Check whether there are "extra runs" for this testdir
1146      extra_runs=      extra_runs=
1147      if test "x$ADM" = x -a "x$use_seperate_build" = x1 ; then      if test "x$ADM" = x ; then
1148          ex_run_dirs=`( cd $dir ; echo input.* )`          ex_run_dirs=`( cd $dir ; echo input.* )`
1149          echo "ex_run_dirs='$ex_run_dirs'"          #echo "ex_run_dirs='$ex_run_dirs'"
1150          for exd in $ex_run_dirs ; do          for exd in $ex_run_dirs ; do
1151              name=`echo $exd | sed -e 's/input.//g'`              name=`echo $exd | sed -e 's/input.//g'`
1152              outf="$dir/results/output.txt.$name"              outf="$dir/results/output.$name.txt"
1153              if test -f $outf -a -r $outf ; then              if test -f $outf -a -r $outf ; then
1154                  extra_runs="$extra_runs $name"                  if test "x$MULTI_THREAD" = "xt" ; then
1155                        if test -r $dir"/"$exd"/eedata.mth" ; then
1156                            extra_runs="$extra_runs $name"
1157                        #else echo $dir"/"$exd"/eedata.mth: not found"
1158                        fi
1159                    else
1160                        extra_runs="$extra_runs $name"
1161                    fi
1162              fi              fi
1163          done          done
1164      fi      fi
1165    
     if test "x$ADM" = x ; then  
         code_dir=code  
         CODE_DIR=$dir/code  
     else  
         code_dir=code_ad  
         CODE_DIR=$dir/code_ad  
     fi  
     BUILD_DIR=$dir/$builddir  
   
     if test ! -r $CODE_DIR"/SIZE.h_mpi" -a "x$MPI" = "xt" ; then  
         echo "can't find \"$CODE_DIR/SIZE.h_mpi\" -- skipping $dir"  
         continue  
     fi  
   
1166      echo "-------------------------------------------------------------------------------"      echo "-------------------------------------------------------------------------------"
1167      echo      echo
1168      echo "Experiment:  $dir"      if test "x$extra_runs" = "x" ; then
1169           echo "Experiment:  $dir"
1170        else
1171           echo "Experiment:  $dir ; extra_runs=$extra_runs"
1172        fi
1173      echo      echo
1174      unset genmake makedepend make run      unset genmake makedepend make run
1175      results='-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- --'      results=$EMPTY_RESULTS
1176    
1177      #  Create an output dir for each OPTFILE/tdir combination      #  Create an output dir for each OPTFILE/tdir combination
1178      rel_CDIR=$DRESULTS"/"$dir      rel_CDIR=$DRESULTS"/"$dir
# Line 943  for dir in $TESTDIRS ; do Line 1180  for dir in $TESTDIRS ; do
1180      CDIR=`pwd`"/$rel_CDIR"      CDIR=`pwd`"/$rel_CDIR"
1181            
1182      if test "x$CLEANUP" = xt ; then      if test "x$CLEANUP" = xt ; then
1183          makeclean $dir/$builddir          echo '====>>> this is to check that we never go through this part <<< ==='
1184            makeclean $dir/$builddir \
1185                && run_clean $dir/$rundir
1186      else      else
1187          genmakemodel $dir/$builddir && genmake=Y \          genmakemodel $dir/$builddir && genmake=Y \
1188              && makeclean $dir/$builddir \              && makeclean $dir/$builddir \
1189                && run_clean $dir/$rundir \
1190              && symlink_mpifiles $dir $code_dir $builddir \              && symlink_mpifiles $dir $code_dir $builddir \
1191              && makedependmodel $dir/$builddir && makedepend=Y \              && makedependmodel $dir/$builddir && makedepend=Y \
1192              && makemodel $dir/$builddir && make=Y \              && makemodel $dir/$builddir && make=Y \
1193              && linkdata $use_seperate_build $dir/$rundir \              && linkdata $dir/$rundir $input_dirs \
1194              && runmodel $dir/$rundir && run=Y \              && runmodel $dir/$rundir && run=Y \
1195              && results=`testoutput $dir $rundir`              && results=`testoutput_run $dir $rundir $ref_outp`
1196      fi      fi
1197            
1198      echo      echo
1199      if test "x$ADM" = x ; then      if test "x$ADM" = x ; then
1200          fres=`formatresults $dir ${genmake:-N} ${makedepend:-N} ${make:-N} ${run:-N} $results`          fres=`formatresults $dir ${genmake:-N} ${makedepend:-N} ${make:-N} ${run:-N} $results`
1201          echo          echo
1202          echo "$fres" >> $SUMMARY          echo "$fres" | sed 's/ 99/ --/g' | sed 's/  > />/' | sed 's/  < /</' >> $SUMMARY
1203          echo "fresults='$fres'" > $CDIR"/summary.txt"          touch $CDIR"/summary.txt"
1204            echo "fresults='$fres'" | sed 's/ 99/ --/g' >> $CDIR"/summary.txt"
1205          echo "MACH='$MACH'" >> $CDIR"/summary.txt"          echo "MACH='$MACH'" >> $CDIR"/summary.txt"
1206          echo "UNAMEA='$UNAMEA'" >> $CDIR"/summary.txt"          echo "UNAMEA='$UNAMEA'" >> $CDIR"/summary.txt"
1207          echo "DATE='$DATE'" >> $CDIR"/summary.txt"          echo "DATE='$DATE'" >> $CDIR"/summary.txt"
1208          echo "tdir='$dir'" >> $CDIR"/summary.txt"          echo "tdir='$dir'" >> $CDIR"/summary.txt"
1209    
         OLD_COMMAND=$COMMAND  
         COMMAND="./mitgcmuv > output.txt"  
1210          for ex in $extra_runs ; do          for ex in $extra_runs ; do
1211              test -e "$dir/tr_run.$ex" && rm -rf "$dir/tr_run.$ex"              unset run
1212              mkdir "$dir/tr_run.$ex"              results=$EMPTY_RESULTS
1213              links=`( cd "$dir/input" > /dev/null 2>&1 ; ls -1 | grep -v CVS )`              #  Create an output dir for each OPTFILE/tdir.ex combination
1214              (              rel_CDIR=$DRESULTS"/"$dir"."$ex
1215                  cd "$dir/tr_run.$ex"              mkdir $rel_CDIR
1216                  for i in $links; do              CDIR=`pwd`"/$rel_CDIR"
1217                      ln -s ../input/$i $i              test ! -e "$dir/tr_run.$ex" && mkdir "$dir/tr_run.$ex"
1218                  done              run_clean $dir/tr_run.$ex
1219              )              linkdata $dir/tr_run.$ex input.$ex input
             links=`( cd "$dir/input.$ex" > /dev/null 2>&1 ; ls -1 | grep -v CVS )`  
             (  
                 cd "$dir/tr_run.$ex"  
                 for i in $links; do  
                     test -e $i  &&  rm -f $i  
                     ln -s ../input.$ex/$i $i  
                 done  
                 ln -s ../$builddir/mitgcmuv mitgcmuv  
             )  
1220              runmodel $dir/tr_run.$ex && run=Y \              runmodel $dir/tr_run.$ex && run=Y \
1221                  && results=`testoutput $dir tr_run.$ex "."$ex`                  && results=`testoutput_run $dir tr_run.$ex "output.${ex}.txt"`
             fres=`printf '%s %s %s %s' ${genmake:-N} ${makedepend:-N} ${make:-N} ${run:-N}`  
1222              fres=`formatresults $dir ${genmake:-N} ${makedepend:-N} ${make:-N} ${run:-N} $results`              fres=`formatresults $dir ${genmake:-N} ${makedepend:-N} ${make:-N} ${run:-N} $results`
1223              fres="$fres.$ex"              fres="$fres.$ex"
1224              echo              echo
1225              echo "$fres" >> $SUMMARY              echo "$fres" | sed 's/ 99/ --/g' | sed 's/  > />/' | sed 's/  < /</' >> $SUMMARY
1226              echo "fresults='$fres'" > $CDIR"/summary.txt"              touch $CDIR"/summary.txt"
1227                echo "fresults='$fres'" | sed 's/ 99/ --/g' >> $CDIR"/summary.txt"
1228              echo "MACH='$MACH'" >> $CDIR"/summary.txt"              echo "MACH='$MACH'" >> $CDIR"/summary.txt"
1229              echo "UNAMEA='$UNAMEA'" >> $CDIR"/summary.txt"              echo "UNAMEA='$UNAMEA'" >> $CDIR"/summary.txt"
1230              echo "DATE='$DATE'" >> $CDIR"/summary.txt"              echo "DATE='$DATE'" >> $CDIR"/summary.txt"
1231              echo "tdir='$dir'" >> $CDIR"/summary.txt"              echo "tdir='$dir.$ex'" >> $CDIR"/summary.txt"
1232                if test "x$POSTCLEAN" = xt ; then
1233                    run_clean $dir/tr_run.$ex
1234                fi
1235          done          done
         COMMAND=$OLD_COMMAND  
1236      else      else
1237          fres=`printf '%s %s %s %s' ${genmake:-N} ${makedepend:-N} ${make:-N} ${run:-N}`          fres=`printf '%s %s %s %s' ${genmake:-N} ${makedepend:-N} ${make:-N} ${run:-N}`
1238          fres=$fres"$results   $dir"          fres=$fres"$results   $dir"
1239          echo          echo
1240          echo "$fres" >> $SUMMARY          echo "$fres" >> $SUMMARY
1241          echo "fresults='$fres'" > $CDIR"/summary.txt"          touch $CDIR"/summary.txt"
1242            echo "fresults='$fres'" >> $CDIR"/summary.txt"
1243          echo "MACH='$MACH'" >> $CDIR"/summary.txt"          echo "MACH='$MACH'" >> $CDIR"/summary.txt"
1244          echo "UNAMEA='$UNAMEA'" >> $CDIR"/summary.txt"          echo "UNAMEA='$UNAMEA'" >> $CDIR"/summary.txt"
1245          echo "DATE='$DATE'" >> $CDIR"/summary.txt"          echo "DATE='$DATE'" >> $CDIR"/summary.txt"
1246          echo "tdir='$dir'" >> $CDIR"/summary.txt"          echo "tdir='$dir'" >> $CDIR"/summary.txt"
1247      fi      fi
1248        if test "x$ADM" = xt ; then
1249            grep -A3 'Seconds in section "ALL' $dir/$rundir/$OUTPUTFILE \
1250                               >> $CDIR"/summary.txt"
1251        fi
1252    
1253        #postclean $dir/$builddir
1254        if test "x$POSTCLEAN" = xt ; then
1255            makeclean $dir/$builddir \
1256                && run_clean $dir/$rundir
1257        fi
1258            
1259      echo "-------------------------------------------------------------------------------"      echo "-------------------------------------------------------------------------------"
1260            
# Line 1049  else Line 1292  else
1292      fi      fi
1293  fi  fi
1294    
1295  # rm -f tmp_cmpnum.f a.out  rm -f tr_cmpnum.c tr_cmpnum
 rm -f tmp_cmpnum.c tmp_cmpnum  
1296    
1297  if test "x$CLEANUP" != xt ; then  if test "x$CLEANUP" != xt ; then
1298      cat $SUMMARY      cat $SUMMARY | sed 's/  \.  \.  \.  \.  \.  \.  \.  \.  \.  \.  \.  \.//'
1299      if test -e tr_out.txt ; then      if test -e tr_out.txt ; then
1300          mv tr_out.txt tr_out.txt.old          mv tr_out.txt tr_out.txt.old
1301      fi      fi
1302      cat $SUMMARY > tr_out.txt      cat $SUMMARY | sed '/^[YN] [YN] [YN] [YN]/ s/  \.//g' > tr_out.txt
1303  fi  fi
1304    
1305  if test "x$DELDIR" = xt ; then  if test "x$DELDIR" = xt ; then

Legend:
Removed from v.1.52  
changed lines
  Added in v.1.99

  ViewVC Help
Powered by ViewVC 1.1.22